﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.51
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Dim UDPSocket1 As UDPSocket
	Private pktUDP, pktDriver, pktTelemetry As Int
	Private mglData As Map
	Private mRaceDriverMap As Map
	Private SpectatorCarIndex As Int
	Private fahrernamen(72) As String
	Private teamnamen(10) As String
	Private PaketTypes(11) As String
	Private driverStatus(7) As String
	Private TyreCompound(9),TC(9) As String
	Private PitStatus(4) As String
	Private FuelMix(4) As String
	Private ResultStatus(8) As String
	Private SessionType(13) As String
	Private Weather(6) As String
	Private TyreMap As Map
	Private bestLapinSession As Float
	Private bestLapinSessionDriver As RaceDriver
	Dim DriverSpectating As String
	Dim SpectatorCarIndex As Int
	Private lastUpdate As Long
	Private bc As ByteConverter
	Private mCallBack As Object
	Private mRaceID As String
	Dim mdb As SQL
	Private glTimer As Timer

	Type pktHeader (packetFormat As Int, packetVersion As Int, packetId As Int, _
     sessionUID As Long, sessionUUID As String, SessionTime As Float, frameIdentifier As Int, PlayerCarIndex As Int)

	Type MarshalZone(ZoneStart As Float, ZoneFlag As Int)

	Type pktSession(Weather As Int, TrackTemperature As Int, AirTemperature As Int, TotalLaps As Int, TrackLength As Int, SessionType As Int, TrackID As Int, Era As Int, SessionTimeLeft As Double, SessionDuration As Double, PitSpeedLimit As Int, GamePaused As Int, IsSpectating As Int, SpectatorCarIndex As Int, sliProNativeSupport As Int, NumMarshalZones As Int, MarshalZones As List,safetyCarStatus As Short, NetworkGame As Int)
	Type pktEventData(Name As String)
	
	Type pktLapData(lastLapTime As Float, currentLapTime As Float, bestLapTime As Float, sector1Time As Float, sector2Time As Float, lapDistance As Float, totalDistance As Float, safetyCarDelta As Float, carPosition As Int, currentLapNum As Int, PitStatus As Int, sector As Int, currentLapInvalid As Int, penalties As Int, gridPosition As Int, driverStatus As Int, ResultStatus As Int)

	Type pktParticipant(AIControlled As Int, DriverID As Int, TeamID As Int, raceNumber As Int, Nationality As Short, Name As String)
	Type pktParticipantData(numCars As Short, DriverList As List)

	Type pktMotionData(CarMotionList As List, suspensionPosition(4) As Float, suspensionVelocity(4) As Float, suspensionAcceleration(4) As Float, wheelSpeed(4) As Float, wheelSlip(4) As Float, localVelocityX As Float, localVelocityY As Float, localVelocityZ As Float, angularVelocityX As Float, angularVelocityY As Float, angularVelocityZ As Float, angularAccelerationX As Float, angularAccelerationY As Float, angularAccelerationZ As Float, frontWheelsAngle As Float)
	
	Type CarMotion(worldPositionX As Float, worldPositionY As Float, worldPositionZ As Float, worldVelocityX As Float, worldVelocityY As Float, worldVelocityZ As Float, worldForwardDirX As Int, worldForwardDirY As Int, worldForwardDirZ As Int, worldRightDirX As Int, worldRightDirY As Int, worldRightDirZ As Int, gForceLateral As Float, gForceLongitudinal As Float, gForceVertical As Float, yaw As Float, Pitch As Float, Roll As Float)

	Type pktCarTelemetryData(CarTelemetryList As List)
	Type CarTelemetry(Speed As Int, throttle As Short, Steer As Short, Brake As Short, Clutch As Short, Gear As Short, engineRPM As Int, drs As Short, revLightsPercent As Short, brakesTemperature(4) As Int, tyresSurfaceTemperature(4) As Int, tyresInnerTemperature(4) As Int, engineTemperature As Int, tyresPressure(4) As Short)

	Type CarSetup(frontWing As Int, rearWing As Int, onThrottle As Int, offThrottle As Int, frontCamber As Float, rearCamber As Float, frontToe As Float, rearToe As Float, frontSuspension As Int, rearSuspension As Int, frontAntiRollBar As Int, rearAntiRollBar As Int, frontSuspensionHeight As Int, rearSuspensionHeight As Int, brakePressure As Int, brakeBias As Int, frontTyrePressure As Float, rearTyrePressure As Float, ballast As Int, fuelLoad As Float, tyresWear(4) As Short)

	Type CarStatus(tractionControl As Short, antiLockBrakes As Short, FuelMix As Short, frontBrakeBias As Short, pitLimiterStatus As Short, fuelInTank As Float, fuelCapacity As Float, maxRPM As Int, idleRPM As Int, maxGears As Short, drsAllowed As Int, TyreCompound As Int, tyresWear1 As Int, tyresWear2 As Int, tyresWear3 As Int, tyresWear4 As Int,tyresDamage1 As Int, tyresDamage2 As Int, tyresDamage3 As Int, tyresDamage4 As Int, frontLeftWingDamage As Short, frontRightWingDamage As Short, rearWingDamage As Short, engineDamage As Short, gearBoxDamage As Short, exhaustDamage As Short, vehicleFiaFlags As Short, ersStoreEnergy As Float, ersDeployMode As Short, ersHarvestedThisLapMGUK As Float, ersHarvestedThisLapMGUH As Float, ersDeployedThisLap As Float)
	
	Type RaceDriver(pos As Int, Driver As String, DriverID As Int, Team As String, TeamID As Int,Grid As Int, stopps As Int, BestLap As Float, Time As Float, Sector1Time As Float, Sector2Time As Float, CurrentLapTime As Float,Punkte As Int, Sector As Int,  BestLapF As String, TimeF As String, Sector1TimeF As String, Sector2TimeF As String, CurrentLapTimeF As String, currentLapNo As Int)

End Sub
	
#Event: UpdateDriverList(drList As List)


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(callBack As Object, GlobalMap As Map, DriverMap As Map, db As SQL)
	mdb = db
	mCallBack = callBack
	mglData = GlobalMap
	mRaceDriverMap = DriverMap
	UDPSocket1.Initialize("UDP", 20777, 1367)
	'UDPSocket1.
	pktUDP = 0
	InitArrays
	bestLapinSession = 999999
	glTimer.Initialize("GobalTimer",2500)

End Sub
Sub EnableTimer
	glTimer.Enabled = True
End Sub
Sub DisableTimer
	glTimer.Enabled = False
End Sub
Public Sub setRaceID(ID As String)
	mRaceID = ID
End Sub
Public Sub getRaceID() As String
	Return mRaceID
End Sub

Sub InitArrays
	'All wheel arrays are in the following order:
	' 0 – Rear Left (RL)
	'	1 – Rear Right (RR)
	'	2 – Front Left (FL)
	' 3 – Front Right (FR)
	SpectatorCarIndex = 0
	DriverSpectating = ""

	mRaceDriverMap.Clear
	TyreMap.Initialize 
	TyreMap.Put("1","rearleft")
	TyreMap.Put("2","rearright")
	TyreMap.Put("3","frontleft")
	TyreMap.Put("4","frontright")
	TyreMap.Put("TC0",CreateMap("green": 10, "green2": 20,"orange":30,"red":40)) ' TC0 =hypersoft
	TyreMap.Put("TC1",CreateMap("green": 15, "green2": 25,"orange":35,"red":45)) ' TC1 =ultrasoft
	TyreMap.Put("TC2",CreateMap("green": 20, "green2": 35,"orange":50,"red":80)) ' TC2 =supersoft
	TyreMap.Put("TC3",CreateMap("green": 35, "green2": 35,"orange":50,"red":80)) ' TC3 =medium
	TyreMap.Put("TC4",CreateMap("green": 50, "green2": 70,"orange":90,"red":200)) ' TC4 =hard (200=kein Rot)
	TyreMap.Put("TC5",CreateMap("green": 80, "green2": 100,"orange":200,"red":200)) ' TC5 =superhard
	TyreMap.Put("TC6",CreateMap("green": 80, "green2": 100,"orange":200,"red":200)) ' TC6 =intermediate
	TyreMap.Put("TC7",CreateMap("green": 80, "green2": 100,"orange":200,"red":200)) ' TC7 =wet


	TyreCompound(0) = "hyper soft"
	TyreCompound(1) = "ultra soft"
	TyreCompound(2) = "super soft"
	TyreCompound(3) = "soft"
	TyreCompound(4) = "medium"
	TyreCompound(5) = "hard"
	TyreCompound(6) = "super hard"
	TyreCompound(7) = "inter"
	TyreCompound(8) = "wet"

	TC(0) = "hypersoft"
	TC(1) = "ultrasoft"
	TC(2) = "supersoft"
	TC(3) = "soft"
	TC(4) = "medium"
	TC(5) = "hard"
	TC(6) = "superhard"
	TC(7) = "intermediate"
	TC(8) = "wet"

	teamnamen(0) = "mercedes"
	teamnamen(1) = "ferrari"
	teamnamen(2) = "redbull"
	teamnamen(3) = "williams"
	teamnamen(4) = "forceindia"
	teamnamen(5) = "renault"
	teamnamen(6) = "tororosso"
	teamnamen(7) = "haas"
	teamnamen(8) = "mclaren"
	teamnamen(9) = "sauber"

	fahrernamen(0) = "Carlos Sainz"
	fahrernamen(1) = "deleted???"
	fahrernamen(2) = "Daniel Ricciardo"
	fahrernamen(3) = "Fernando Alonso"
	fahrernamen(4) = "deleted???"
	fahrernamen(5) = "deleted???"
	fahrernamen(6) = "Kimi Raikkönen"
	fahrernamen(7) = "Lewis Hamilton"
	fahrernamen(8) = "Marcus Ericsson"
	fahrernamen(9) = "Max Verstappen"
	fahrernamen(10) = "Nico Hülkenberg"
	fahrernamen(11) = "Kevin Magnussen"
	fahrernamen(12) = "Romain Grosjean"
	fahrernamen(13) = "Sebastian Vettel"
	fahrernamen(14) = "Sergio Perez"
	fahrernamen(15) = "Valtteri Bottas"
	fahrernamen(17) = "Esteban Ocon"
	fahrernamen(18) = "Stoffel Vandoorne"
	fahrernamen(19) = "Lance Stroll"
	fahrernamen(20) = "Arron Barnes"
	fahrernamen(21) = "Martin Giles"
	fahrernamen(22) = "Alex Murray"
	fahrernamen(23) = "Lucas Roth"
	fahrernamen(24) = "Igor Correia"
	fahrernamen(25) = "Sophie Levasseur "
	fahrernamen(26) = "Jonas Schiffer"
	fahrernamen(27) = "Alain Forest"
	fahrernamen(28) = "Jay Letourneau"
	fahrernamen(29) = "Esto Saari"
	fahrernamen(30) = "Yasar Atiyeh"
	fahrernamen(31) = "Callisto Calabresi"
	fahrernamen(32) = "Naota Izum"
	fahrernamen(33) = "Howard Clarke"
	fahrernamen(34) = "Wilheim Kaufmann"
	fahrernamen(35) = "Marie Laursen "
	fahrernamen(36) = "Flavio Nieves"
	fahrernamen(37) = "Peter Belousov"
	fahrernamen(38) = "Klimek Michalski "
	fahrernamen(39) = "Santiago Moreno"
	fahrernamen(40) = "Benjamin Coppens"
	fahrernamen(41) = "Noah Visser"
	fahrernamen(42) = "Gert Waldmuller"
	fahrernamen(43) = "Julian Quesada"
	fahrernamen(44) = "Daniel Jones"
	fahrernamen(58) = "Charles Leclerc"
	fahrernamen(59) = "Pierre Gasly"
	fahrernamen(60) = "Brendon Hartley"
	fahrernamen(61) = "Sergey Sirotkin"
	fahrernamen(69) = "Ruben Meijer"
	fahrernamen(70) = "Rashid Nair"
	fahrernamen(71) = "Jack Tremblay"
	
	
	FuelMix(0) = "len"
	FuelMix(1) = "standard"
	FuelMix(2) = "rich"
	FuelMix(2) = "max"
	Weather(0) = "clear"
	Weather(1) = "light cloud"
	Weather(2) = "overcast"
	Weather(3) = "light rain"
	Weather(4) = "heavy rain"
	Weather(5) = "storm"
	ResultStatus(0) = "invalid"
	ResultStatus(1) = "inactive"
	ResultStatus(2) = "active"
	ResultStatus(3) = "finished"
	ResultStatus(4) = "disqualified"
	ResultStatus(5) = "Not classified"
	ResultStatus(6) = "retired"
	ResultStatus(7) = "unkown"
	PitStatus(0) = "none"
	PitStatus(1) = "pitting"
	PitStatus(2) = "in pit area"
	PitStatus(3) = "unknown"


	PaketTypes(0) = "Motion"
	PaketTypes(1) = "Session"
	PaketTypes(2) = "Lap Data"
	PaketTypes(3) = "Event"
	PaketTypes(4) = "Participants"
	PaketTypes(5) = "Car Setup"
	PaketTypes(6) = "Car Telemetry"
	PaketTypes(7) = "Car Status"
	
	' Status of driver - 0 = in garage, 1 = flying lap, 2 = in lap, 3 = out lap, 4 = on track
	driverStatus(0) = "in Garage"
	driverStatus(1) = "flying lap"
	driverStatus(2) = "Boxeneinfahrt"
	driverStatus(3) = "Boxenausfahrt"
	driverStatus(4) = "on track"
	driverStatus(5) = "unknown"

	SessionType(0) = "unknown"
	SessionType(1) = "P1"
	SessionType(2) = "P2"
	SessionType(3) = "P3"
	SessionType(7) = "Short P"
	SessionType(5) = "Q1"
	SessionType(6) = "Q2"
	SessionType(7) = "Q3"
	SessionType(8) = "Short Q"
	SessionType(9) = "OSQ"
	SessionType(10) = "R"
	SessionType(11) = "R2"
	SessionType(12) = "Time Trial"

End Sub

Sub UDP_PacketArrived (Packet As UDPPacket)
	pktUDP = pktUDP +1
	Dim timestamp As Long = DateTime.Now

	'Private udpcapture As RandomAccessFile
	'udpcapture.Initialize(File.DirApp,"UDP-Capture."&RaceID&"_"&pktUDP&".bin",False)
	'Dim pkt() As Byte = Packet.Data
	'udpcapture.WriteB4XObject(pkt,udpcapture.CurrentPosition)
	'udpcapture.Close
	
	Dim raf As RandomAccessFile
	raf.Initialize3(Packet.Data, True) 'change the endianess if the version number is incorrect
	Dim hdr As pktHeader =  ParseHeader(raf)
	'Dim header() As Byte = bb.SubArray2(0,21)
	'Dim hexhdr As String = bconv.HexFromBytes(header)

	'writeloghex($"Packet: ${PaketTypes(hdr.packetId)} "$)
	'writeloghex($"Packet: Header:${header.Length} ${hexhdr} "$)
	'Dim hex As String = bconv.HexFromBytes(Packet.Data)
	'writeloghex($"Packet: Size:${Packet.Data.Length} ${hex} "$)
	
	'writelog($"Paket: ${hex} "$)
	'writelog($"Format: ${hdr.packetFormat} V:${hdr.packetVersion} S:${hdr.sessionUID} UUID:${hdr.sessionUUID} Frame: ${hdr.frameIdentifier} Type: ${PaketTypes(hdr.packetId)} CarIdx: ${hdr.PlayerCarIndex}  "$)
	Dim value As Int = hdr.packetId
	Select value
		Case 0
			'Log("Motion")
			Dim motion As pktMotionData = parseMotionData(raf)
			If motion.CarMotionList.IsInitialized And motion.CarMotionList.Size > 0 Then
				For i = 0 To motion.CarMotionList.Size-1
					Dim carmotion As CarMotion = motion.CarMotionList.Get(i)
					If mglData.ContainsKey("Driver"&i) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&i, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&i)
					m.Put("CarMotionPKT",carmotion)
					m.Put("Pitch",carmotion.Pitch)
					m.Put("Roll",carmotion.Roll)
					m.Put("worldPositionX",carmotion.worldPositionX)
					m.Put("worldPositionY",carmotion.worldPositionY)
					m.Put("worldPositionZ",carmotion.worldPositionZ)
					m.Put("gForceLateral",carmotion.gForceLateral)
					m.Put("gForceLongitudinal",carmotion.gForceLongitudinal)
					m.Put("gForceVertical",carmotion.gForceVertical)
					m.Put("worldForwardDirX",carmotion.worldForwardDirX)
					m.Put("worldForwardDirY",carmotion.worldForwardDirY)
					m.Put("worldForwardDirZ",carmotion.worldForwardDirZ)
					m.Put("worldRightDirX",carmotion.worldRightDirX)
					m.Put("worldRightDirY",carmotion.worldRightDirY)
					m.Put("worldRightDirZ",carmotion.worldRightDirZ)
					m.Put("worldVelocityX",carmotion.worldVelocityX)
					m.Put("worldVelocityY",carmotion.worldVelocityY)
					m.Put("worldVelocityZ",carmotion.worldVelocityZ)
					m.Put("yaw",carmotion.yaw)
					Log($"CarMotion Car #${i}: X:${carmotion.worldPositionX}: Y:${carmotion.worldPositionY}, Z:${carmotion.worldPositionZ}, Pitch: ${carmotion.Pitch} "$)

				Next
			End If
	
		Case 1
			Dim session As pktSession = parseSession(raf)
			Log($"Session: UID:${hdr.sessionUID} UUID:${hdr.sessionUUID} Track: ${session.TrackID}, Weather: ${session.Weather}, AirTemp: ${session.AirTemperature}, Temperatur: ${session.TrackTemperature}, PL-Limit: ${session.PitSpeedLimit} Duration: ${session.SessionDuration}, TimeLeft: ${session.SessionTimeLeft} NumMarshalzones: ${session.NumMarshalZones}, GamePaused: ${session.GamePaused}, Spectating: ${session.IsSpectating}, SafetyCarStatus: ${session.safetyCarStatus}, Network: ${session.NetworkGame} "$)
			If mglData.ContainsKey("Session") = False Then
				Dim newmap As Map
				newmap.Initialize
				mglData.Put("Session", newmap)
			End If
			Dim m As Map = mglData.Get("Session")
			m.Put("SessionPKT",session)
			m.Put("AirTemperature",session.AirTemperature)
			m.Put("Era",session.Era)
			m.Put("GamePaused",session.GamePaused)
			m.Put("IsSpectating",session.IsSpectating)
			SpectatorCarIndex = session.IsSpectating

			'm.Put("MarshalZones",session.MarshalZones)
			m.Put("NetworkGame",session.NetworkGame)
			m.Put("NumMarshalZones",session.NumMarshalZones)
			m.Put("PitSpeedLimit",session.PitSpeedLimit)
			m.Put("safetyCarStatus",session.safetyCarStatus)
			m.Put("SessionDuration",session.SessionDuration)
			m.Put("SessionTimeLeft",session.SessionTimeLeft)
			m.Put("SessionTime",hdr.SessionTime)
			m.Put("SessionUUID",hdr.sessionUID)
			
			If session.SessionType > -1 And session.SessionType <= 12 Then
				m.Put("SessionType",SessionType(session.SessionType))
			Else
				m.Put("SessionType",SessionType(0))
			End If
			m.Put("sliProNativeSupport",session.sliProNativeSupport)
			m.Put("SpectatorCarIndex",session.SpectatorCarIndex)
			m.Put("TotalLaps",session.TotalLaps)
			m.Put("TrackID",session.TrackID)
			m.Put("TrackLength",session.TrackLength)
			m.Put("TrackTemperature",session.TrackTemperature)
			m.Put("Weather", Weather(session.Weather))
			' session.MarshalZones
			Dim mzl As List = session.MarshalZones
			If mzl.IsInitialized And mzl.Size > 0 Then
				For o=0 To mzl.Size-1
					Dim mz As MarshalZone = mzl.Get(o)
					Dim zone As Int  = o +1
					m.Put("MZStart_"&zone, mz.ZoneStart)
					m.Put("MZFlag_"&zone, mz.ZoneFlag)
					
				Next
			End If
			Do While mzl.Size < 20 Then
				Dim zone As Int = mzl.Size-1
				Dim mz As MarshalZone
				mz.Initialize
				mz.ZoneStart = 0
				mz.ZoneFlag = 0
				m.Put("MZStart_"&zone, mz.ZoneStart)
				m.Put("MZFlag_"&zone, mz.ZoneFlag)
				mzl.Add(mz)
			Loop
			'm.Put("MarshalZones", session.MarshalZones)
						
			'writelog($"Session: UUID:${hdr.sessionUID} Track: ${session.TrackID}, Weather: ${session.Weather}, AirTemp: ${session.AirTemperature}, Temperatur: ${session.TrackTemperature}, PL-Limit: ${session.PitSpeedLimit} Duration: ${session.SessionDuration}, TimeLeft: ${session.SessionTimeLeft} NumMarshalzones: ${session.NumMarshalZones}, GamePaused: ${session.GamePaused}, Spectating: ${session.IsSpectating}, SafetyCarStatus: ${session.safetyCarStatus}, Network: ${session.NetworkGame} "$)
		Case 2
			'Log("LapData")
			Dim ldl As List = parseLapData(raf)
			If ldl.IsInitialized And ldl.Size > 0 Then
				'Log(ldl.Size)
				For t = 0 To ldl.Size-1
					'Log("Adding LapData #"&t)
					Dim ld As pktLapData = ldl.Get(t)
					If mglData.ContainsKey("Driver"&t) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&t, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&t)
					m.Put("LapDataPKT",ld)
					m.Put("carPosition",ld.carPosition)
					m.Put("currentLapInvalid",ld.currentLapInvalid)
					m.Put("currentLapNum",ld.currentLapNum)
					If ld.driverStatus > -1 And ld.driverStatus <= 5 Then
						m.Put("driverStatus",driverStatus(ld.driverStatus))
					Else
						m.Put("driverStatus",driverStatus(5))
					End If
					m.Put("gridPosition",ld.gridPosition)
					m.Put("lapDistance",ld.lapDistance)
					m.Put("penalties",ld.penalties)
					
					If ld.pitStatus > -1 And ld.pitStatus <= 2 Then
						m.Put("pitStatus",PitStatus(ld.pitStatus))
					Else
						m.Put("pitStatus",PitStatus(3))
					End If
					If ld.resultStatus > -1 And ld.resultStatus <= 6 Then
						m.Put("resultStatus",ResultStatus(ld.resultStatus))
					Else
						m.Put("resultStatus",ResultStatus(7))
					End If
					m.Put("safetyCarDelta",ld.safetyCarDelta)
					m.Put("Sector",ld.sector)

					m.Put("sector1Time",ld.sector1Time)
					m.Put("sector2Time",ld.sector2Time)
					m.Put("currentLapTime",ld.currentLapTime)
					m.Put("lastLapTime",ld.lastLapTime)
					m.Put("bestLapTime", ld.bestLapTime)
					m.Put("bestLapTimeF",fnc.FormatTime(ld.bestLapTime))

					m.Put("sector1TimeF",fnc.FormatTime(ld.sector1Time))
					m.Put("sector2TimeF",fnc.FormatTime(ld.sector2Time))
					m.Put("currentLapTimeF",fnc.FormatTime(ld.currentLapTime))
					m.Put("lastLapTimeF",fnc.FormatTime(ld.lastLapTime))
					m.Put("bestLapTimeF",fnc.FormatTime(ld.bestLapTime))

					m.Put("totalDistance",ld.totalDistance)

					If mRaceDriverMap.ContainsKey("Driver"&t) = False Then
						Dim driver As RaceDriver
						driver.Initialize
						mRaceDriverMap.Put("Driver"&t, driver)
					End If
					Dim driver As RaceDriver = mRaceDriverMap.Get("Driver"&t)
					driver.BestLap = ld.bestLapTime
					driver.Grid = ld.gridPosition
					driver.pos = ld.carPosition
					
					driver.currentLapNo = ld.currentLapNum
					driver.BestLapF = fnc.FormatTime(ld.bestLapTime)
					driver.BestLap = ld.bestLapTime
					If ld.bestLapTime > 1 And bestLapinSession > ld.bestLapTime Then
						bestLapinSession = ld.bestLapTime
						bestLapinSessionDriver = driver
						'changeBestLap(driver,ld.bestLapTime)
						CallSub3(Main,"changeBestLap",driver, ld.bestLapTime)
					End If
					
					'driver.Punkte =
					'driver.stopps = 0
					
					driver.Sector1Time = ld.sector1Time
					driver.Sector1TimeF = fnc.FormatTime(ld.sector1Time)
					driver.Sector2Time = ld.sector2Time
					driver.Sector2TimeF = fnc.FormatTime(ld.sector2Time)
					driver.CurrentLapTime = ld.currentLapTime
					driver.CurrentLapTimeF = fnc.FormatTime(ld.currentLapTime)
					driver.Sector = ld.sector
					
					If DriverSpectating <> "" Then
						If lastUpdate < DateTime.Now-500 Then
							lastUpdate = DateTime.Now
							'CallSub2(dv,"UpdateDriver2",driver)
						End If
					End If
					Log($"LapData Driver #${i}: UUID:${hdr.sessionUID}: CurrTime: ${ld.currentLapTime}, BestLapTime: ${ld.bestLapTime}, LapDist: ${ld.lapDistance}, TotalDist: ${ld.totalDistance}, CarPosition: ${ld.carPosition} CurrLapNum ${ld.currentLapNum}, Sector: ${ld.sector}, Sec1Time: ${ld.sector1Time}, Sec2Time: ${ld.sector2Time}, Penalties: ${ld.penalties} "$)
				Next
			Else
				'Log("LapDataList leer?")
			End If
		Case 3
			'Log("Event")
			Dim event As pktEventData
			event.Initialize
			
			Dim buffer(4) As Byte
			raf.ReadBytes(buffer,0,buffer.Length,21) 'fnc.ReadString(raf, buffer).Replace(Chr(0),Chr(32)).Trim
			
			event.Name = bc.StringFromBytes(buffer,"UTF-8") ' BytesToString(buffer, 0, buffer.Length, "utf8")
			Log($"UUID:${hdr.sessionUID}: EventName: ${event.Name}"$)
			'log($"UUID:${hdr.sessionUID}: EventName: ${event.Name}"$)
			If event.Name = "SSTA" Then
				mglData.Clear
			else if event.Name = "SEND" Then
				'udpcapture.Close
				'btnStop_Click
				'wcl.ListFiles(File.DirApp,False, "UDP-Capture."&RaceID&"_"&"*.bin, *.log, *.txt",False, True)

			End If
			
		Case 4
			'Log($"Participants: "$)
			Dim part As pktParticipantData = ParseParticipantData(raf)
			Log($"UUID:${hdr.sessionUID}: ParticipantsData: ${part.numCars} "$)
			Dim ldl As List = part.DriverList
			If ldl.IsInitialized And ldl.Size > 0 Then
				
				For i = 0 To ldl.Size-1
					Dim p As pktParticipant = ldl.Get(i)
					If mglData.ContainsKey("Driver"&i) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&i, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&i)
					m.Put("ParticipantPKT",p)
					m.Put("DriverID",p.DriverID)
					m.Put("AIControlled",p.AIControlled)
					m.Put("Name",p.Name)
					m.Put("Nationality",p.Nationality)
					m.Put("raceNumber",p.raceNumber)
					m.Put("TeamID",p.TeamID)
					
					If mRaceDriverMap.ContainsKey("Driver"&i) = False Then
						Dim driver As RaceDriver
						driver.Initialize
						mRaceDriverMap.Put("Driver"&i, driver)
					End If
					Dim driver As RaceDriver = mRaceDriverMap.Get("Driver"&i)
					'Log(driver)
					'Log(p)
					'Log(rd.GetTable.Items)
					'Log(rd.GetTable.Items.Get(i))
					'If p.TeamID <> Null Then
					'driver.TeamID = p.TeamID
					'End If
					driver.Driver = p.Name
					driver.DriverID = p.DriverID
					driver.Team = p.TeamID
					
					
					'                                       'Pos,       Fahrer,        Team,        Grid,        Stopps,        BestLap,        Sektor1,            Sektor2,            PKT
					'rd.GetTable.Items.Set(i,Array As Object(driver.pos, driver.Driver, driver.Team, driver.Grid, driver.stopps, driver.BestLap, driver.Sector1Time, driver.Sector2Time, driver.Punkte))
					'rd.GetTable.Items.so Sort(True)

					'rd.GetTable.Items.Set(i,Array As Object(driver.pos, driver.Driver, driver.Team, driver.Grid, driver.stopps, driver.BestLap, driver.Sector1Time, driver.Sector2Time, driver.Punkte))
					'rd.GetTable.Items.Set(i,driver)
					Log($"Participants Driver #${i}: UUID:${hdr.sessionUID}: DriverID: ${p.DriverID}, TeamID: ${p.TeamID}, RaceNo: ${p.raceNumber}, Name: ${p.Name}, AI: ${p.AIControlled} "$)
				Next

				Dim driverlist As List
				driverlist.Initialize
				For i = 0 To ldl.Size-1
					Dim p As pktParticipant = ldl.Get(i)
					
					If mRaceDriverMap.ContainsKey("Driver"&i) = False Then
						Dim driver As RaceDriver
						driver.Initialize
						mRaceDriverMap.Put("Driver"&i, driver)
					End If
					Dim driver As RaceDriver = mRaceDriverMap.Get("Driver"&i)
					driverlist.Add(driver)
				Next
				driverlist.SortType("pos",True)
				If DriverSpectating <> "" Then
					Dim driverspec As RaceDriver = mRaceDriverMap.Get(DriverSpectating)
					CallSub3(mCallBack,"UpdateDriverList",driverlist, driverspec)
				Else
					CallSub3(mCallBack,"UpdateDriverList",driverlist, Null)					
				End If







'				For o = 0 To driverlist.Size-1
'					Dim driver As RaceDriver = driverlist.Get(o)
'					Log(rd.GetTable.GetBase)
'					'Log(rd.GetTable.GetBase.GetView(o))
'					Log(rd.GetTable.GetPanel(o))
'					Dim bp As B4XView = rd.GetTable.GetPanel(o)
'					Log(bp)
'					Dim verbesserung As Int = 0
'					Dim gridpos As Int = driver.pos
'					If o=gridpos Then
'						verbesserung = 0
'					else if o > gridpos Then
'						verbesserung = gridpos-o
'					else if o < gridpos Then
'						verbesserung = gridpos-o
'					End If
				'
'					Dim idx As Int = 0
'					For Each v As B4XView In bp.GetAllViewsRecursive
'						If v Is Label Then
'							Log(GetType(v))
'							Log("Label at idx "&idx)
'							'Dim lbl As Label = v
'							Select idx
'								Case 0
'									Dim lblPos As Label = v
'									lblPos = bp.GetView(0)
'									lblPos.Text = driver.pos
'									lblPos.Font = fx.DefaultFont(12)
'									lblPos.TextColor = fx.Colors.Black
'									Dim color As String
'									If o Mod 2 = 0 Then color = "palegreen" Else color = "skyblue"
'									lblPos.Style = "-fx-background-color: " & color & ";"
'								Case 2
'									Dim lblPlusMinus As Label = v
'									lblPlusMinus.Font = fx.CreateFontAwesome(12)
'									If driver.pos < driver.Grid Then
'										lblPlusMinus.TextColor = fx.Colors.Green
'										'lblPlusMinus.Style = $"-fx-background-image: url(${File.GetUri(File.DirAssets, "up.png")});"$
'									Else If driver.pos > driver.Grid Then
'										lblPlusMinus.TextColor = fx.Colors.Red
'										'lblPlusMinus.Style = $" -fx-background-image: url(${File.GetUri(File.DirAssets, "down.png")});"$
'									End If
'									If verbesserung > 0 Then
'										lblPlusMinus.Text = "+"&verbesserung
'									Else
'										lblPlusMinus.Text = verbesserung
'									End If
'								Case 4
'									Dim lblFahrer As Label = v
'									lblFahrer = bp.GetView(2)
'									lblFahrer.Text = driver.Driver
'									lblFahrer.Font = fx.DefaultFont(12)
'									lblFahrer.TextColor = fx.Colors.Blue
'								Case 6
'									Dim lblTeam As Label = v
'									lblTeam = bp.GetView(3)
'									lblTeam.Text = driver.Team
'									lblTeam.Font = fx.DefaultFont(12)
'									lblTeam.TextColor = fx.Colors.Green
'								Case 8
'									Dim lblGrid As Label = v
'									lblGrid.Text = driver.Grid
'									lblGrid.Font = fx.DefaultFont(12)
'									lblGrid.TextColor = fx.Colors.Black
'								Case 10
'									Dim lblStops As Label = v
'									lblStops.Text = driver.stopps
'									lblStops.Font = fx.DefaultFont(12)
'									lblStops.TextColor = fx.Colors.Black
'								Case 12
'									Dim lblBestLap As Label = v
'									lblBestLap.Text = driver.BestLap
'									lblBestLap.Font = fx.DefaultFont(12)
'									lblBestLap.TextColor = fx.Colors.Magenta
'								Case 14
'									Dim lblSektor1 As Label = v
'									lblSektor1.Text = driver.Sector1Time
'									lblSektor1.Font = fx.DefaultFont(12)
'									lblSektor1.TextColor = fx.Colors.Yellow
'								Case 16
'									Dim lblSektor2 As Label = v
'									lblSektor2.Text = driver.Sector2Time
'									lblSektor2.Font = fx.DefaultFont(12)
'									lblSektor2.TextColor = fx.Colors.Black
'								Case 18
'									Dim lblPKT As Label = v
'									lblPKT.Text = driver.Punkte
'									lblPKT.Font = fx.DefaultFont(12)
'									lblPKT.TextColor = fx.Colors.Black
'							End Select
'						Else
'							Log(GetType(v))
'						End If
'						idx = idx +1
'					Next
				'bp.
				'Dim pan As Label = bp.GetView(0)
					
			End If
		Case 5
			'Log("Car Setup")
			Dim setuplist As List = parseCarSetup(raf)
			If setuplist.IsInitialized And setuplist.Size > 0 Then
				For i = 0 To setuplist.Size-1
					If mglData.ContainsKey("Driver"&i) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&i, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&i)
					Dim cs As CarSetup = setuplist.Get(i)
					m.Put("CarSetupPKT",cs)
					m.Put("Ballast",cs.ballast)
					m.Put("brakeBias",cs.brakeBias)
					m.Put("brakePressure",cs.brakePressure)
					m.Put("frontAntiRollBar",cs.frontAntiRollBar)
					m.Put("frontCamber",cs.frontCamber)
					m.Put("frontSuspension",cs.frontSuspension)
					m.Put("frontSuspensionHeight",cs.frontSuspensionHeight)
					m.Put("frontToe",cs.frontToe)
					m.Put("frontTyrePressure",cs.frontTyrePressure)
					m.Put("frontWing",cs.frontWing)

					m.Put("rearAntiRollBar",cs.rearAntiRollBar)
					m.Put("rearCamber",cs.rearCamber)
					m.Put("rearSuspension",cs.rearSuspension)
					m.Put("rearSuspensionHeight",cs.rearSuspensionHeight)
					m.Put("rearToe",cs.rearToe)
					m.Put("rearTyrePressure",cs.rearTyrePressure)
					m.Put("rearWing",cs.rearWing)
					m.Put("fuelLoad",cs.fuelLoad)
					m.Put("offThrottle",cs.offThrottle)
					m.Put("onThrottle",cs.onThrottle)

					Log($"CarSetup #${i}: UUID:${hdr.sessionUID}: Ballast: ${cs.ballast}, FuelLoad: ${cs.fuelLoad} "$)
			
				Next
			End If

		Case 6
			'Log("Car Telemetry")
			Dim telelist As List = parseCarTelemetryData(raf)
			If telelist.IsInitialized And telelist.Size > 0 Then
				For i = 0 To telelist.Size-1
					Dim ct As CarTelemetry = telelist.Get(i)
					
					If mglData.ContainsKey("Driver"&i) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&i, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&i)
					m.Put("CarTelemetryPKT",ct)
					m.Put("Brake",ct.Brake)
					m.Put("brakesTemperature1",ct.brakesTemperature(0))
					m.Put("brakesTemperature2",ct.brakesTemperature(1))
					m.Put("brakesTemperature3",ct.brakesTemperature(2))
					m.Put("brakesTemperature4",ct.brakesTemperature(3))
					m.Put("Clutch",ct.Clutch)
					m.Put("drs",ct.drs)
					m.Put("engineRPM",ct.engineRPM)
					m.Put("engineTemperature",ct.engineTemperature)
					m.Put("Gear",ct.Gear)
					m.Put("revLightsPercent",ct.revLightsPercent)
					m.Put("Speed",ct.Speed)
					m.Put("Steer",ct.Steer)
					m.Put("throttle",ct.throttle)

					'Log($"CarTelemetry #${i}: UUID:${hdr.sessionUID}: Gear: ${ct.Gear}, Speed: ${ct.Speed}, EngineRPM: ${ct.engineRPM}, EngineTemp: ${ct.engineTemperature} "$)
			
				Next
			End If

		Case 7
			'Log("Car Status")
			Dim ldl As List = parseCarStatus(raf)
			If ldl.IsInitialized And ldl.Size > 0 Then
				For i = 0 To ldl.Size-1
					Dim stat As CarStatus = ldl.Get(i)
					If mglData.ContainsKey("Driver"&i) = False Then
						Dim newmap As Map
						newmap.Initialize
						mglData.Put("Driver"&i, newmap)
					End If
					Dim m As Map = mglData.Get("Driver"&i)
					m.Put("CarStatusPKT",stat)
					m.Put("antiLockBrakes",stat.antiLockBrakes)
					m.Put("drsAllowed",stat.drsAllowed)
					m.Put("engineDamage",stat.engineDamage)
					m.Put("ersDeployedThisLap",stat.ersDeployedThisLap)
					m.Put("ersDeployMode",stat.ersDeployMode)
					m.Put("ersHarvestedThisLapMGUH",stat.ersHarvestedThisLapMGUH)
					m.Put("ersHarvestedThisLapMGUK",stat.ersHarvestedThisLapMGUK)
					m.Put("ersStoreEnergy",stat.ersStoreEnergy)
					m.Put("exhaustDamage",stat.exhaustDamage)
					m.Put("frontBrakeBias",stat.frontBrakeBias)
					m.Put("frontLeftWingDamage",stat.frontLeftWingDamage)
					m.Put("frontRightWingDamage",stat.frontRightWingDamage)
					m.Put("fuelCapacity",stat.fuelCapacity)
					m.Put("fuelInTank",stat.fuelInTank)
					m.Put("fuelMix",stat.fuelMix)
					m.Put("gearBoxDamage",stat.gearBoxDamage)
					m.Put("idleRPM",stat.idleRPM)
					m.Put("maxGears",stat.maxGears)
					m.Put("maxRPM",stat.maxRPM)
					m.Put("pitLimiterStatus",stat.pitLimiterStatus)
					m.Put("rearWingDamage",stat.rearWingDamage)
					m.Put("tractionControl",stat.tractionControl)
					m.Put("tyreCompound",TyreCompound(stat.tyreCompound))
					m.Put("tyresDamage1",stat.tyresDamage1)
					m.Put("tyresDamage2",stat.tyresDamage2)
					m.Put("tyresDamage3",stat.tyresDamage3)
					m.Put("tyresDamage4",stat.tyresDamage4)
					m.Put("tyresWear1",stat.tyresWear1)
					m.Put("tyresWear2",stat.tyresWear2)
					m.Put("tyresWear3",stat.tyresWear3)
					m.Put("tyresWear4",stat.tyresWear4)
					m.Put("vehicleFiaFlags",stat.vehicleFiaFlags)

					'Log($"CarStatus #${i}: UUID:${hdr.sessionUID}: vehicleFiaFlags: ${stat.vehicleFiaFlags}, exhaustDamage: ${stat.exhaustDamage}, engineDamage: ${stat.engineDamage} "$)

				Next
			End If
		Case Else
			Log("UnknownPaketType")
	End Select
	'Log("sessionUUID:"&hdr.sessionUID)
	'Log("PaketTyp:"&hdr.packetId)
	'Log("Frame:"&hdr.frameIdentifier)
	'Log("PlayerCarIndex:"&hdr.PlayerCarIndex)
	raf.Close
	If (pktUDP Mod 25) = 0 Then
		CallSubDelayed2(mCallBack,"UpdatePaketUDP",pktUDP)
	End If
End Sub


Sub ParseHeader(raf As RandomAccessFile) As pktHeader
	'Log("ParseMessage("&data.Length&")")
	Dim hdr As pktHeader
	hdr.Initialize
	hdr.packetFormat = fnc.ShortToUnsigned(raf.ReadShort(0))
	hdr.packetVersion = raf.ReadunSignedByte(2)
	hdr.packetId = raf.ReadunSignedByte(3)
	
	hdr.sessionUID = raf.ReadLong(4)
	hdr.SessionTime = raf.ReadFloat(12)
	hdr.frameIdentifier = raf.ReadInt(16)
	hdr.PlayerCarIndex = raf.ReadunSignedByte(20)
	hdr.sessionUUID = mRaceID
	Return hdr
End Sub
Sub parseMotionData(raf As RandomAccessFile) As pktMotionData
	Dim ldl As List
	ldl.Initialize
	Dim pos As Int = 21

	For i = 0 To 19
		Dim car As CarMotion
		car.Initialize
		car.worldPositionX = raf.ReadFloat(pos)
		pos = pos +4
		car.worldPositionY = raf.ReadFloat(pos)
		pos = pos +4
		car.worldPositionZ = raf.ReadFloat(pos)
		pos = pos +4
		car.worldVelocityX = raf.ReadFloat(pos)
		pos = pos +4
		car.worldVelocityY = raf.ReadFloat(pos)
		pos = pos +4
		car.worldVelocityZ = raf.ReadFloat(pos)
		pos = pos +4
		
		car.worldForwardDirX = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.worldForwardDirY = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.worldForwardDirZ = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.worldRightDirX = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.worldRightDirY = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.worldRightDirZ = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2

		car.gForceLateral = raf.ReadFloat(pos)
		pos = pos +4
		car.gForceLongitudinal = raf.ReadFloat(pos)
		pos = pos +4

		car.gForceVertical = raf.ReadFloat(pos)
		pos = pos +4

		car.yaw = raf.ReadFloat(pos)
		pos = pos +4
		
		Dim p As Float = raf.ReadFloat(pos)
		car.Pitch = p
		pos = pos +4
		car.Roll = raf.ReadFloat(pos)
		pos = pos +4
		ldl.Add(car)
	Next
	Dim motion As pktMotionData
	motion.Initialize
	motion.CarMotionList = ldl
	motion.suspensionPosition(0) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionPosition(1) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionPosition(2) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionPosition(3) = raf.ReadFloat(pos)
	pos = pos +4
	
	motion.suspensionVelocity(0) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionVelocity(1) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionVelocity(2) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionVelocity(3) = raf.ReadFloat(pos)
	pos = pos +4

	motion.suspensionAcceleration(0) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionAcceleration(1) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionAcceleration(2) = raf.ReadFloat(pos)
	pos = pos +4
	motion.suspensionAcceleration(3) = raf.ReadFloat(pos)
	pos = pos +4

	motion.wheelSpeed(0) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSpeed(1) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSpeed(2) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSpeed(3) = raf.ReadFloat(pos)
	pos = pos +4

	motion.wheelSlip(0) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSlip(1) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSlip(2) = raf.ReadFloat(pos)
	pos = pos +4
	motion.wheelSlip(3) = raf.ReadFloat(pos)
	pos = pos +4

	motion.localVelocityX = raf.ReadFloat(pos)
	pos = pos +4
	motion.localVelocityY = raf.ReadFloat(pos)
	pos = pos +4
	motion.localVelocityZ = raf.ReadFloat(pos)
	pos = pos +4

	motion.angularVelocityX = raf.ReadFloat(pos)
	pos = pos +4
	motion.angularVelocityY = raf.ReadFloat(pos)
	pos = pos +4
	motion.angularVelocityZ = raf.ReadFloat(pos)
	pos = pos +4
	
	motion.angularAccelerationX = raf.ReadFloat(pos)
	pos = pos +4
	motion.angularAccelerationY = raf.ReadFloat(pos)
	pos = pos +4
	motion.angularAccelerationZ = raf.ReadFloat(pos)
	pos = pos +4
	motion.frontWheelsAngle = raf.ReadFloat(pos)
	pos = pos +4

	Return motion
End Sub
Sub parseSession(raf As RandomAccessFile) As pktSession
	Dim session As pktSession
	session.Initialize
	session.Weather = raf.ReadSignedByte(21)
	session.TrackTemperature = raf.ReadSignedByte(22)
	session.AirTemperature = raf.ReadSignedByte(23)
	session.TotalLaps = raf.ReadunSignedByte(24)
	session.TrackLength = fnc.ShortToUnsigned(raf.ReadShort(25))
	session.SessionType = raf.ReadunSignedByte(27)
	session.TrackID = raf.ReadSignedByte(28)
	session.Era = raf.ReadunSignedByte(29)
	session.SessionTimeLeft = fnc.ShortToUnsigned(raf.ReadShort(30))
	session.SessionDuration = fnc.ShortToUnsigned(raf.ReadShort(32))
	session.PitSpeedLimit = raf.ReadunSignedByte(34)
	session.GamePaused = raf.ReadunSignedByte(35)
	session.IsSpectating = raf.ReadunSignedByte(36)
	session.spectatorCarIndex = raf.ReadunSignedByte(37)
	session.sliProNativeSupport = raf.ReadunSignedByte(38)
	session.NumMarshalZones = raf.ReadunSignedByte(39)
	Dim mzones As List
	mzones.Initialize
	Dim pos As Int = 40
	For i= 0 To session.NumMarshalZones-1
		Dim mz As MarshalZone
		mz.Initialize
		mz.ZoneStart = raf.ReadFloat(pos)
		pos = pos +4
		mz.ZoneFlag = raf.ReadsignedByte(pos)
		pos = pos +1

		mzones.Add(mz)
	Next
	Do While mzones.Size < 20 Then
		Dim mz As MarshalZone
		mz.Initialize
		mz.ZoneStart = 0
		mz.ZoneFlag = 0
		mzones.Add(mz)
	Loop
	
	
	session.MarshalZones = mzones
	session.safetyCarStatus = raf.ReadunSignedByte(pos)
	session.NetworkGame = raf.ReadunSignedByte(pos+1)
	Return session
End Sub
Sub parseLapData(raf As RandomAccessFile) As List
	Dim ldl As List
	ldl.Initialize
	Dim pos As Int = 21

	For i = 0 To 19
		Dim ld As pktLapData
		ld.Initialize
		'float       m_currentLapTime;        // Current time around the lap in seconds
		ld.lastLapTime = raf.ReadFloat(pos)
		pos = pos +4
		ld.currentLapTime = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_bestLapTime;           // Best lap time of the session in seconds
		ld.bestLapTime = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_sector1Time;           // Sector 1 time in seconds
		ld.sector1Time = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_sector2Time;           // Sector 2 time in seconds
		ld.sector2Time = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_lapDistance;           // Distance vehicle Is around current lap in metres – could be negative If line hasn’t been crossed yet
		ld.lapDistance = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_totalDistance;         // Total distance travelled in session in metres – could be negative If line hasn’t been crossed yet
		ld.totalDistance = raf.ReadFloat(pos)
		pos = pos +4
		'float       m_safetyCarDelta;        // Delta in seconds For safety car
		ld.safetyCarDelta = raf.ReadFloat(pos)
		pos = pos +4
		'uint8       m_carPosition;           // Car race position
		ld.carPosition = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_currentLapNum;         // Current lap number
		ld.currentLapNum = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_pitStatus;             // 0 = none, 1 = pitting, 2 = in pit area
		ld.pitStatus = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_sector;                // 0 = sector1, 1 = sector2, 2 = sector3
		ld.sector = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_currentLapInvalid;     // Current lap invalid - 0 = valid, 1 = invalid
		ld.currentLapInvalid = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_penalties;             // Accumulated time penalties in seconds To be added
		ld.penalties = raf.ReadSignedByte(pos)
		pos = pos +1
		'uint8       m_gridPosition;          // Grid position the vehicle started the race in
		ld.gridPosition = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_driverStatus;          // Status of driver - 0 = in garage, 1 = flying lap, 2 = in lap, 3 = out lap, 4 = on track
		ld.driverStatus = raf.ReadUnsignedByte(pos)
		pos = pos +1
		'uint8       m_resultStatus;          // Result status - 0 = invalid, 1 = inactive, 2 = active, 3 = finished, 4 = disqualified, 5 = Not classified, 6 = retired
		ld.resultStatus = raf.ReadUnsignedByte(pos)
		pos = pos +1
		ldl.Add(ld)
	Next
	
	Return ldl
End Sub
Sub ParseParticipantData(raf As RandomAccessFile) As pktParticipantData
	'Log("ParseMessage("&data.Length&")")
	Dim pd As pktParticipantData
	pd.Initialize
	pd.numCars = raf.ReadunSignedByte(21)

	Dim Driver As List
	Driver.Initialize
	Dim pos As Int = 22
	For i= 0 To pd.numCars-1
		Dim p As pktParticipant
		p.Initialize

		'uint8      m_aiControlled;           // Whether the vehicle Is AI (1) Or Human (0) controlled
		p.AIControlled = raf.ReadunSignedByte(pos)
		pos = pos + 1
		'uint8      m_driverId;               // Driver id - see appendix
		p.DriverID = raf.ReadUnsignedByte(pos)
		pos = pos + 1
		'uint8      m_teamId;                 // Team id - see appendix
		p.TeamID = raf.ReadUnsignedByte(pos)
		pos = pos + 1
		'uint8      m_raceNumber;             // Race number of the car
		p.raceNumber = raf.ReadunSignedByte(pos)
		pos = pos + 1
		'uint8      m_nationality;            // Nationality of the driver
		p.Nationality = raf.ReadunSignedByte(pos)
		pos = pos + 1
		'char       m_name[48];               // Name of participant in UTF-8 format – Null terminated. Will be truncated with … (U+2026) If too long
		'driver.Name =
		Dim buffer(48) As Byte
		'raf.ReadBytes(buffer,0,buffer.Length,26) '
		p.Name = fnc.ReadString(raf, buffer).Replace(Chr(0),Chr(32)).Trim


		pos = pos +48
		'Log($"Participant: DriverID: ${p.DriverID}, TeamID: ${p.TeamID}, raceNumber: ${p.raceNumber}, : ${p.Name} "$)
		If mRaceDriverMap.ContainsKey("Driver"&i) = False Then
			Dim dr As RaceDriver
			dr.Initialize
			mRaceDriverMap.Put("Driver"&i, dr)
		End If
		Dim dr As RaceDriver = mRaceDriverMap.Get("Driver"&i)
		dr.DriverID = p.DriverID
		dr.Driver = p.Name
		dr.TeamID = p.TeamID

		Driver.Add(p)
	Next
	pd.DriverList = Driver
			
	'driver.Name = bc.StringFromBytes(buffer,"UTF-8").Replace(Chr(0),Chr(32)).Trim ' BytesToString(buffer, 0, buffer.Length, "utf8")

	Return pd
End Sub
Sub parseCarSetup(raf As RandomAccessFile) As List
	Dim l As List
	l.Initialize
	Dim pos As Int = 21

	For i = 0 To 19
		Dim car As CarSetup
		car.Initialize
		car.frontWing = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.rearWing = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.onThrottle = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.offThrottle = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.frontCamber = raf.ReadFloat(pos)
		pos = pos +4
		car.rearCamber = raf.ReadFloat(pos)
		pos = pos +4
		car.frontToe = raf.ReadFloat(pos)
		pos = pos +4
		car.rearToe = raf.ReadFloat(pos)
		pos = pos +4
		car.frontSuspension = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.rearSuspension = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.frontAntiRollBar = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.rearAntiRollBar = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.frontSuspensionHeight = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.rearSuspensionHeight = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.brakePressure = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.brakeBias = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.frontTyrePressure = raf.ReadFloat(pos)
		pos = pos +4
		car.rearTyrePressure = raf.ReadFloat(pos)
		pos = pos +4
		car.ballast = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.fuelLoad = raf.ReadFloat(pos)
		pos = pos +4

		l.Add(car)
	Next
	Return l
End Sub
Sub parseCarTelemetryData(raf As RandomAccessFile) As List
	Dim telelist As List
	telelist.Initialize
	Dim pos As Int = 21
	
	For i = 0 To 19
		'raf.ReadBytes(a,0,a.Length,pos)' .ReadUnsignedByte(pos)
		Dim car As CarTelemetry
		car.Initialize

		Dim speed As Int = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.Speed = speed
		'Log($"CarSpeed #${i}: ${speed}}"$)
		car.throttle = raf.ReadUnSignedByte(pos)
		pos = pos +1
		car.Steer = raf.ReadSignedByte(pos)
		pos = pos +1
		car.Brake = raf.ReadunSignedByte(pos)
		pos = pos +1
		car.Clutch = raf.ReadunSignedByte(pos)
		pos = pos +1
		car.Gear = raf.ReadSignedByte(pos)
		pos = pos +1
		car.engineRPM = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.drs = raf.ReadunSignedByte(pos)
		pos = pos +1
		car.revLightsPercent = raf.ReadSignedByte(pos)
		pos = pos +1

		car.brakesTemperature(0) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.brakesTemperature(1) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.brakesTemperature(2) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.brakesTemperature(3) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2

		car.tyresSurfaceTemperature(0) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresSurfaceTemperature(1) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresSurfaceTemperature(2) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresSurfaceTemperature(3) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2

		car.tyresInnerTemperature(0) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresInnerTemperature(1) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresInnerTemperature(2) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		car.tyresInnerTemperature(3) = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2

		car.engineTemperature = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2

		car.tyresPressure(0) = raf.ReadFloat(pos)
		pos = pos +4
		car.tyresPressure(1) = raf.ReadFloat(pos)
		pos = pos +4
		car.tyresPressure(2) = raf.ReadFloat(pos)
		pos = pos +4
		car.tyresPressure(3) = raf.ReadFloat(pos)
		pos = pos +4
		telelist.Add(car)
	Next
	'Dim tele As pktCarTelemetryData
	'tele.Initialize
	'tele.CarTelemetryList = telelist
	Return telelist
End Sub
Sub parseCarStatus(raf As RandomAccessFile) As List
	Dim carlist As List
	carlist.Initialize
	Dim pos As Int = 21
	
	For i = 0 To 19
		Dim car As CarStatus
		car.Initialize
		'	uint8       tractionControl;          // 0 (off) - 2 (high)
		car.tractionControl = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       antiLockBrakes;           // 0 (off) - 1 (on)
		car.antiLockBrakes = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       fuelMix;                  // Fuel mix - 0 = lean, 1 = standard, 2 = rich, 3 = Max
		car.fuelMix = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       frontBrakeBias;           // Front brake bias (percentage)
		car.frontBrakeBias = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       pitLimiterStatus;         // Pit limiter status - 0 = off, 1 = on
		car.pitLimiterStatus = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	float       fuelInTank;               // Current fuel mass
		car.fuelInTank = raf.ReadFloat(pos)
		pos = pos +4
		'	float       fuelCapacity;             // Fuel capacity
		car.fuelCapacity = raf.ReadFloat(pos)
		pos = pos +4
		'	uint16      maxRPM;                   // Cars Max RPM, point of rev limiter
		car.maxRPM = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		'	uint16      idleRPM;                  // Cars idle RPM
		car.idleRPM = fnc.ShortToUnsigned(raf.ReadShort(pos))
		pos = pos +2
		'	uint8       maxGears;                 // Maximum number of gears
		car.maxGears = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       drsAllowed;               // 0 = Not allowed, 1 = allowed, -1 = unknown
		car.drsAllowed = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       tyresWear[4];             // Tyre wear percentage
		For t = 1 To 4
			If t = 1 Then
				car.tyresWear1 = raf.ReadUnSignedByte(pos)
			else if t = 2 Then
				car.tyresWear2 = raf.ReadUnSignedByte(pos)
			else if t = 3 Then
				car.tyresWear3 = raf.ReadUnSignedByte(pos)
			else if t = 4 Then
				car.tyresWear4 = raf.ReadUnSignedByte(pos)
			End If
			pos = pos +1
		Next
		'	uint8       tyreCompound;
		' // Modern
		' 0 = hyper soft, 1 = ultra soft, 2 = super soft, 3 = soft, 4 = medium, 5 = hard, 6 = super hard, 7 = inter, 8 = wet
		'	// Classic - 0-6 = dry, 7-8 = wet
		car.tyreCompound = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       tyresDamage[4];           // Tyre damage (percentage)
		For t = 0 To 3
			If t = 1 Then
				car.tyresDamage1 = raf.ReadUnSignedByte(pos)
			else if t = 2 Then
				car.tyresDamage2 = raf.ReadUnSignedByte(pos)
			else if t = 3 Then
				car.tyresDamage3 = raf.ReadUnSignedByte(pos)
			else if t = 4 Then
				car.tyresDamage4 = raf.ReadUnSignedByte(pos)
			End If

			pos = pos +1
		Next

		'	uint8       frontLeftWingDamage;      // Front left wing damage (percentage)
		car.frontLeftWingDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       frontRightWingDamage;     // Front right wing damage (percentage)
		car.frontRightWingDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       rearWingDamage;           // Rear wing damage (percentage)
		car.rearWingDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       engineDamage;             // Engine damage (percentage)
		car.engineDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       gearBoxDamage;            // Gear box damage (percentage)
		car.gearBoxDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	uint8       exhaustDamage;            // Exhaust damage (percentage)
		car.exhaustDamage = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	int8        vehicleFiaFlags;
		' -1 = invalid/unknown, 0 = none, 1 = green, 2 = blue, 3 = yellow, 4 = red
		car.vehicleFiaFlags = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	float       ersStoreEnergy;           // ERS energy store in Joules
		car.ersStoreEnergy = raf.ReadFloat(pos)
		pos = pos +4
		'	uint8       ersDeployMode;            // ERS deployment mode, 0 = none, 1 = low, 2 = medium, 3 = high, 4 = overtake, 5 = hotlap
		car.ersDeployMode = raf.ReadUnSignedByte(pos)
		pos = pos +1
		'	float       ersHarvestedThisLapMGUK;  // ERS energy harvested this lap by MGU-K
		car.ersHarvestedThisLapMGUK = raf.ReadFloat(pos)
		pos = pos +4
		'	float       ersHarvestedThisLapMGUH;  // ERS energy harvested this lap by MGU-H
		car.ersHarvestedThisLapMGUH = raf.ReadFloat(pos)
		pos = pos +4
		'	float       ersDeployedThisLap;       // ERS energy deployed this lap
		car.ersDeployedThisLap = raf.ReadFloat(pos)
		pos = pos +4

		
		carlist.Add(car)
	Next
	Return carlist
End Sub

Sub GobalTimer_Tick
	'osglobal = File.OpenOutput(File.DirApp,"UDP_Globals.LOG",True)
	Dim timestamp As Long = DateTime.Now
	
	Log($"GobalTimer_Tick($date{timestamp} $time{timestamp})"$)
	If mglData.ContainsKey("Session") Then
		Dim sessmap As Map = mglData.Get("Session")
		If sessmap.ContainsKey("SessionPKT") Then
			Dim sess As pktSession = sessmap.Get("SessionPKT")
			'Log($"GobalTimer_Tick(${sess})"$)

		End If
		'
	End If

	For i= 0 To 19
		Dim m As Map = mglData.Get("Driver"&i)
		If m.IsInitialized Then
			If m.ContainsKey("CarMotionPKT") Then
				'Log("CarMotionPKT gefunden")
			Else
				'Log("CarMotionPKT FEHLT!!")
			End If
			If m.ContainsKey("LapDataPKT") Then
				'Log("LapDataPKT gefunden")
			Else
				Log("LapDataPKT FEHLT!!")
			End If
			If m.ContainsKey("ParticipantPKT") Then
				'Log("ParticipantPKT gefunden")
			Else
				'Log("ParticipantPKT FEHLT!!")
			End If
			If m.ContainsKey("CarSetupPKT") Then
				'Log("CarSetupPKT gefunden")
			Else
				'Log("CarSetupPKT FEHLT!!")
			End If
			If m.ContainsKey("CarTelemetryPKT") Then
				If m.ContainsKey("CarTelemetryPKT") Then
					'Log("CarTelemetryPKT gefunden")
				Else
					'Log("CarTelemetryPKT FEHLT!!")
				End If
				If m.ContainsKey("CarStatusPKT") Then
					'Log("CarStatusPKT gefunden")
				Else
					'Log("CarStatusPKT FEHLT!!")
				End If

				If m.ContainsKey("CarMotionPKT") And m.ContainsKey("LapDataPKT") And m.ContainsKey("ParticipantPKT") And m.ContainsKey("CarSetupPKT")And m.ContainsKey("CarTelemetryPKT") And m.ContainsKey("CarStatusPKT") Then
					Dim motion As CarMotion = m.Get("CarMotionPKT")
					Dim lapdata As pktLapData = m.Get("LapDataPKT")
					Dim part As  pktParticipant = m.Get("ParticipantPKT")
					Dim setup As  CarSetup = m.Get("CarSetupPKT")
					Dim telemtry As CarTelemetry = m.Get("CarTelemetryPKT")
					Dim status As CarStatus = m.Get("CarStatusPKT")

				End If
			End If
		End If
	Next

End Sub
