﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
  Public FIniMap As Map                      ' Map holding the ini Keys=Values
  Public FIniFile As String = "CarsUDP.ini"    ' Textfile in which the inimap is stored 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(inifile As String)
  ' Init the inimap
  FIniMap.Initialize
  ' Read the content of the inifile and assigne content to the inimap
  FIniFile = inifile
	FIniMap = readIni(FIniFile)

End Sub


' SECTION: INI
' The ini file is stored in the app folder (same as where the jar file is stored)

' Read the Ini values from the ini file into a global map
' Param IniFile: The ini file to be read
' Return: Map of ini entries (key=Value)
Public Sub readIni(IniFile As String) As Map
	Dim Map1 As Map
  Map1.Initialize
  ' If the ini file exists, read it else create an empty file
  If File.Exists(File.DirApp, IniFile) = True Then
    Map1 = File.ReadMap(File.DirApp, IniFile)
  Else
    File.WriteMap(File.DirApp, IniFile, Map1)    
  End If
  Return Map1
End Sub

' Save the ini values  from the map into a file
' Parameter Map: Map holding the ini entries
' Parameter IniFile: The ini file holding the entries
Public Sub saveIni
    File.WriteMap(File.DirApp, FIniFile, FIniMap)
End Sub

' Delete the ini file
' Parameter IniFile: The ini file to be deleted
Public Sub deleteIni(IniFile As String)
    File.Delete(File.DirApp, IniFile)
End Sub

' Get an Ini value from the map for a given key. if not found, use default value.
' Parameter Map: Map holding the ini entries
' Parameter Key: Key to be changed or added
' Parameter Default: Default value to be assigned to the key
' Return: Ini value as String
Public Sub getIni(Key As String, Default As String) As String
  Dim s As String
	Dim f As Boolean = False
  s = Default
  For i = 0 To FIniMap.Size - 1
    If FIniMap.GetKeyAt(i) = Key Then
      s = FIniMap.GetValueAt(i)
			f = True
    End If
  Next
	If f = False Then
		FIniMap.Put(Key,s)
	End If
  Return s
End Sub

' Put an Ini value for a key into the map
' Parameter Map: Map holding the ini entries
' Parameter Key: Key to be changed or added
' Parameter Value: Value to be assigned to the key
Public Sub putKey(Key As String, Value As String)
  FIniMap.put(Key, Value)
End Sub

' Delete an Ini value from the map for for a key
' Parameter Map: Map holding the ini entries
' Parameter Key: Key as String to delete from the map
Public Sub removeKey(Key As String)
	FIniMap.Remove(Key)
End Sub