﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=4
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub
Sub LogByte(b As Byte)
   Log(NumberFormat2(Bit.ToBinaryString(Bit.And(0xff, b)), 8, 0, 0, False))
End Sub
Sub SetBit(b As Byte, index As Int, on As Boolean) As Byte
   If on Then
      Return Bit.Or(b, Bit.ShiftLeft(1, index))
   Else
      Return Bit.And(b, Bit.Not(Bit.ShiftLeft(1, index)))
   End If
End Sub
Sub FormatTime(val As Float) As String
	DateTime.TimeFormat="mm:ss.SSS"
	'Log(DateTime.Time(val*DateTime.TicksPerSecond))
	Return DateTime.Time(val*DateTime.TicksPerSecond)
End Sub
Sub ConvertShort (barray() As Byte) As Short()
	Private bc As ByteConverter
	Private shorts() As Short
	bc.LittleEndian = True
	shorts=bc.ShortsFromBytes(barray)
	Return shorts
End Sub
Sub ShortToUnsigned(s As Short) As Int
	Return Bit.And(0xFFFF, s)
End Sub
Sub ToUnsigned(b As Byte) As Int
   Return Bit.And(0xFF, b)
End Sub
Sub ReadString(raf As RandomAccessFile, buffer() As Byte) As String
   raf.ReadBytes(buffer, 0, buffer.Length, raf.CurrentPosition)
   Return BytesToString(buffer, 0, buffer.Length, "utf8")
End Sub
Sub DirUserDefault As String
   Dim jo As JavaObject
   Return jo.InitializeStatic("javax.swing.filechooser.FileSystemView").RunMethodJO("getFileSystemView", _
     Null).RunMethodJO("getDefaultDirectory", Null).RunMethod("getAbsolutePath", Null)
End Sub
Sub GetFilename(fullpath As String) As String
	Return fullpath.SubString(fullpath.LastIndexOf("/") + 1)
End Sub
Sub GetFileExt(FullPath As String) As String
  Return FullPath.SubString(FullPath.LastIndexOf(".")+1)
End Sub
Sub GetBasename(fullpath As String) As String
   Dim filename As String
   filename = GetFilename(fullpath)
   Return filename.SubString2(0,filename.LastIndexOf("."))
End Sub
Sub GetPath(Path As String) As String
   Dim Path1 As String
   If Path = "/" Then
      Return "/"
   End If
   Dim L As Int
	 L = Path.LastIndexOf("/")
   If L = Path.Length - 1 Then
      'Strip the last slash
      Path1 = Path.SubString2(0,L)
   Else
      Path1 = Path
   End If
   L = Path.LastIndexOf("/")
   If L = 0 Then
      L = 1
   End If
   Return Path1.SubString2(0,L)
End Sub

Sub SetFormFromMap(m As Map, f As Form)
	f.WindowLeft = m.Get("left")
	f.WindowTop = m.Get("top")
	f.WindowWidth = m.Get("width")
	f.WindowHeight = m.Get("height")
	Dim iconified As Boolean = m.Get("iconified")
	If iconified Then
		Dim jo As JavaObject = f
		jo.GetFieldJO("stage").RunMethod("setIconified", Array(iconified))
	End If
	'check that left and top are in screen boundaries
	Dim goodLeft, goodTop As Boolean
	For Each screen As Screen In fx.Screens
		If f.WindowLeft >= screen.MinX And f.WindowLeft <= screen.MaxX Then
			goodLeft = True
		End If
		If f.WindowTop >= screen.MinY And f.WindowTop <= screen.MaxY Then
			goodTop = True
		End If
	Next
	If Not(goodLeft) Then f.WindowLeft = 0
	If Not(goodTop) Then f.WindowTop = 0
End Sub
Sub FormToMap (f As Form) As Map
	Dim m As Map = CreateMap("left": f.WindowLeft, "top": f.WindowTop, "width": f.WindowWidth, _
     "height": f.WindowHeight)
	Dim jo As JavaObject = f
	m.Put("iconified": jo.GetFieldJO("stage").RunMethod("isIconified", Null))
	Return m
End Sub
